<?php

namespace Bazookas\AdminBundle\AdminElements\Containers;

use Bazookas\AdminBundle\AdminElements\Base\BaseAdminElement;
use Bazookas\AdminBundle\AdminElements\Interfaces\AdminElementInterface;

class RowContainer extends BaseAdminElement {

  //the bootstrap column width each child should get
  public $defaultChildColClass;

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);

    $this->defaultChildColClass = $this->options['defaultColClass'];
  }

  public function getChildWidth($index)
  {
    $child = $this->children[$index];

    if (!empty($child) && $child instanceof AdminElementInterface) {
      $colClass = $child->getColClass();
      if (!empty($colClass)) {
        return $colClass;
      }
    }

    return $this->defaultChildColClass;
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:AdminElements/Containers:rowContainer.html.twig',
      'class' => 'row',
      'defaultColClass' => 'col-md-4'
    ]);
  }
}
