<?php

namespace Bazookas\AdminBundle\AdminElements\Elements\Actions\Base;

use Bazookas\AdminBundle\AdminElements\Base\BaseAdminElement;

class BaseActionElement extends BaseAdminElement
{

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'route' => '',
      'action' => '',
      'label' => '',
      'routeParams' => [],
    ]);
  }

  public function getRoute()
  {
    return $this->options['route'];
  }

  /**
   * @param string $route
   * @return $this
   */
  public function setRoute($route) {
    $this->options['route'] = $route;
    return $this;
  }

  public function getAction() {
    return $this->options['action'];
  }

  public function getRouteParams() {
    return $this->options['routeParams'];
  }

  /**
   * @param array $routeParams
   * @return $this
   */
  public function setRouteParams(array $routeParams) {
    $this->options['routeParams'] = $routeParams;
    return $this;
  }
}
