<?php

namespace Bazookas\AdminBundle\Dashboard\Containers;

use Bazookas\AdminBundle\Dashboard\Base\BaseDashboardElement;
use Bazookas\AdminBundle\Dashboard\Interfaces\DashboardElementInterface;

/**
 * @deprecated
 *
 * Class RowContainer
 * @package Bazookas\AdminBundle\Dashboard\Containers
 */
class RowContainer extends BaseDashboardElement {

  //the bootstrap column width each child should get
  public $defaultChildColClass;

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);

    $this->defaultChildColClass = $this->options['defaultColClass'];
  }

  public function getChildWidth($index)
  {
    $child = $this->children[$index];

    if (!empty($child) && $child instanceof DashboardElementInterface) {
      $options = $child->getOptions();

      if (isset($options['colClass']) && !empty($options['colClass'])) {
        return $options['colClass'];
      }
    }

    return $this->defaultChildColClass;
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:Dashboard/Containers:rowContainer.html.twig',
      'class' => 'row',
      'defaultColClass' => 'col-md-4'
    ]);
  }
}
