<?php

namespace Bazookas\AdminBundle\PageBuilder\Interfaces;

use Bazookas\AdminBundle\AdminElements\Interfaces\AdminElementInterface;
use Symfony\Component\HttpFoundation\Request;

interface ListPageBuilderInterface extends PageBuilderInterface
{

  /**
   * Build the List table admin element
   * @param Request $request
   * @return AdminElementInterface
   */
  public function buildListTable(Request $request);

  /**
   * Get the number of items to be shown in the table
   * @return int
   */
  public function getLimit();

  /**
   * @param int $limit
   * @return $this
   */
  public function setLimit($limit);

  /**
   * @return array
   */
  public function getListQueryParams();

  /**
   * @param array $listQueryParams
   * @return $this
   */
  public function setListQueryParams(array $listQueryParams);

  /**
   * @return bool
   */
  public function isAjaxPageable();

  /**
   * @param bool $ajaxPageable
   * @param null $pageAction
   * @return $this
   */
  public function setAjaxPageable($ajaxPageable, $pageAction = null);

  /**
   * @return string
   */
  public function getPageAction();

  /**
   * @param string $pageAction
   * @return $this
   */
  public function setPageAction($pageAction);

  /**
   * @return bool
   */
  public function isInlineEditable();

  /**
   * @param bool $inlineEditable
   * @return $this
   */
  public function setInlineEditable($inlineEditable);

  /**
   * @param $fieldName
   * @param array $options
   * @return $this
   */
  public function addField($fieldName, array $options = []);

  /**
   * @param $fieldName
   * @param array $options
   * @return $this
   */
  public function addFilterField($fieldName, array $options = []);

}
