### AdminElements

### General

An element is loosely defined ot be an item which is rendered directly onto the page. A container is an element which usually holds other child elements and renders them in a certain way. A container therefore only provides the functionality necessary to render its children and to navigate through those children (if necessary).

Note that each element or container can always be given the following options:
```php
  protected function getDefaultOptions() {
    return [
      'roles' => ['ROLE_ADMIN'],
      'template' => '',
      'class' => '',
      'value' => null,
      'label' => '',
      'colClass' => '',
      'icon' => '', // for things like tabbed panel or flippable container,
      'iconClass' => '',
      'navName' => ''
    ];
  }
```
Any additional options which can be used with specific elements is mentioned in their documentation.

- [Elements](./elements.md)
- [Containers](./containers.md)
