<?php

namespace WebsiteBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass="WebsiteBundle\Repository\UnlockedQuoteRepository")
 * @ORM\HasLifecycleCallbacks
 */
class UnlockedQuote extends BaseEntity {

  /**
   * @ORM\ManyToOne(targetEntity="WebsiteBundle\Entity\Quote")
   * @var Quote
   */
  private $quote;

  /**
   * @ORM\ManyToOne(targetEntity="WebsiteBundle\Entity\Participant", inversedBy="unlockedQuotes")
   * @var Participant
   */
  private $participant;

  /**
   * @ORM\OneToOne(targetEntity="WebsiteBundle\Entity\TestSession")
   * @var TestSession
   */
  private $session;

  /**
   * @ORM\Column(type="boolean")
   * @var bool
   */
  private $viewed = false;

  /**
   * @return Quote
   */
  public function getQuote()
  {
    return $this->quote;
  }

  /**
   * @param Quote $quote
   * @return $this
   */
  public function setQuote(Quote $quote)
  {
    $this->quote = $quote;

    return $this;
  }

  /**
   * @return Participant
   */
  public function getParticipant()
  {
    return $this->participant;
  }

  /**
   * @param Participant $participant
   * @return UnlockedQuote
   */
  public function setParticipant($participant)
  {
    $this->participant = $participant;

    return $this;
  }

  /**
   * @return bool
   */
  public function isViewed()
  {
    return $this->viewed;
  }

  /**
   * @param bool $viewed
   * @return $this
   */
  public function setViewed($viewed)
  {
    $this->viewed = $viewed;

    return $this;
  }

  /**
   * @return TestSession
   */
  public function getSession()
  {
    return $this->session;
  }

  /**
   * @param TestSession $session
   * @return $this
   */
  public function setSession($session)
  {
    $this->session = $session;

    return $this;
  }

}
