<?php

namespace WebsiteBundle\Form\Admin;

use Bazookas\AdminBundle\Form\Type\EntityPickerType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use WebsiteBundle\Entity\Quote;
use WebsiteBundle\Entity\Test;

class QuoteAdminType extends AbstractType
{

  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('quote', TextareaType::class, [
        'label' => 'admin.entities.quote.fields.quote'
      ])
      ->add('type', ChoiceType::class, [
        'label' => 'admin.entities.quote.fields.type',
        'choices' => [
          'admin.entities.quote.enums.TYPE_MASTER' => Quote::TYPE_MASTER,
          'admin.entities.quote.enums.TYPE_GENERIC' => Quote::TYPE_GENERIC,
        ],
        'disabled' => $builder->getData()->getId() !== null
      ])
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults([
      'data_class' => Quote::class,
      'translation_domain' => 'admin'
    ]);
  }
}
