<?php

namespace WebsiteBundle\Repository;

use Bazookas\AdminBundle\Repository\Base\BaseRepository;
use WebsiteBundle\Entity\TestAnswer;

class TestAnswerRepository extends BaseRepository
{

  public function getEntityClass() {
    return TestAnswer::class;
  }

  public function createAnswerExportQuery($sessionId) {
    $qb = $this->createQueryBuilder('answer');
    $qb
      ->addSelect('participant')
      ->leftJoin('answer.participant', 'participant')

      ->addSelect('session')
      ->leftJoin('answer.session', 'session')

      ->andWhere($qb->expr()->eq('answer.session', ':session'))
      ->setParameter('session', $sessionId)
    ;
    return $qb;
  }

  public function createListQueryBuilder(array $fields, array $params) {
    $qb = parent::createListQueryBuilder($fields, $params);

    $sessionId = $params['sessionId'];
    $qb
      ->andWhere($qb->expr()->eq('e.session', ':sessionId'))
      ->setParameter('sessionId', $sessionId)
    ;

    return $qb;
  }
}
