<?php

namespace Bazookas\AdminBundle\Repository;

use Bazookas\AdminBundle\Entity\CMSUserGroup;
use Bazookas\AdminBundle\Repository\Base\BaseRepository;
use FOS\UserBundle\Model\GroupInterface;

class CMSUserGroupRepository extends BaseRepository
{

  /**
   * @deprecated to be removed in v2.
   * Deprecation reason: Let the class metadata decide this through the parent function
   * @return string
   */
  public function getEntityClass() {
    return CMSUserGroup::class;
  }

  /**
   * @param string $systemId
   * @param array $roles the roles that should be given to the group in case it cannot be found
   * @return CMSUserGroup
   * @throws \Exception
   */
  public function getOrCreateGroupBySystemId($systemId, array $roles) {
    $qb = $this->createQueryBuilder('userGroup');

    $qb
      ->andWhere($qb->expr()->eq('userGroup.systemId', ':systemId'))
      ->setParameter('systemId', $systemId)
    ;

    $group = $qb->getQuery()->getOneOrNullResult();
    if (empty($result)) {
      $className = $this->getEntityClass();
      $group = new $className();

      if (!$group instanceof CMSUserGroup) {
        throw new \Exception('Expected entity to be an instance of \''.CMSUserGroup::class.'\' got \''.get_class($group).'\' instead.');
      }

      $group
        ->setName('defaultGroup-'.$systemId)
        ->setSystemId($systemId)
        ->setRoles($roles)
      ;

      $this->_em->persist($group);
      $this->_em->flush();
    }

    return $group;
  }
}
