<?php

namespace Bazookas\AdminBundle\Twig;

use Bazookas\AdminBundle\Services\Notification\NotificationService;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface;

class NotificationExtension  extends \Twig_Extension
{
  /**
   * @var NotificationService
   */
  private $notificationService;

  /**
   * @var TokenStorageInterface
   */
  private $storage;

  public function __construct(NotificationService $notificationService, TokenStorageInterface $storage) {
    $this->notificationService = $notificationService;
    $this->storage = $storage;
  }

  public function getFunctions() {
    return array(
      new \Twig_SimpleFunction('getCMSNotifications', array($this, 'getCMSNotifications')),
    );
  }

  public function getCMSNotifications() {
    $user = $this->storage->getToken()->getUser();

    return $this->notificationService->getCMSNotificationsForUser($user);
  }

}
