## Installing
### With composer
Add the following to composer.json (composer will ask authentication for private bundles the first time you install a bazookas bundle)
```php
    "repositories": [
        {
            "type": "vcs",
            "url": "https://github.com/Bazookastudios/BazookasAPIFrameworkBundle.git"
        }
    ],
```

And then: `composer require bazookas/api-framework-bundle`

### As a git submodule
Use this command in the root of your repository to add this bundle as a submodule.

```bash
git submodule add -b master --name APIFrameworkBundle https://github.com/Bazookastudios/BazookasAPIFrameworkBundle.git ./src/Bazookas/APIFrameworkBundle
```
## Activating the installation
### Activate in AppKernel.php

```php
      new Bazookas\AdminBundle\BazookasAPIFrameworkBundle(),
```

### Add to app/routing.yml

```yml
api_framework:
    resource: "@BazookasAPIFrameworkBundle/Resources/config/routing.yml"
    prefix:   /
```

### Add to app/config.yml
```yml
fos_oauth_server:
  db_driver: orm
  client_class:        APIBundle\Entity\OAuth2Client
  access_token_class:  APIBundle\Entity\OAuth2AccessToken
  refresh_token_class: APIBundle\Entity\OAuth2RefreshToken
  auth_code_class:     APIBundle\Entity\OAuth2AuthCode
  service:
    user_provider: APIFrameworkBundle.user_provider.BaseUserProvider
    options:
      # Changing tokens and authcode lifetime
      access_token_lifetime: 86400     # 1 day
      refresh_token_lifetime: 1209600  # 14 days

# bazookas api framework configuration
bazookas_api_framework:
  # when using api file uploader
  file_upload:
    settings:
      # optional configuration and their defaults
      root_directory: '%kernel.root_dir%/../web'
      uploads_root_directory: '%kernel.root_dir%/../web/uploads'
      # when no base url is provided (or null) it will default to the router context
      # dynamically getting base url from request
      baseUrl: ~
      # required
      uploadRoute: api_v1_upload

# Enable nelmio documentation generator
nelmio_api_doc: ~
```
