# Bazookas\CommonBundle\Command\Deploy\PostDeployCommand

This command will clear the cache, set file permissions for new folders and try composer autoload optimisation.

It is possible that, when the command has to create folders, the site won't load for a few seconds (don't ask why, 'cause I dunno).

## Clearing the cache

`php bin/console cache:clear --env=prod --no-debug --no-warmup`

## Folder permissions

The following folders will be created if not present
- var
- web/uploads
- web/media (default imagine cache location)

And the following commands will be executed to ensure the permissions are set correctly

```bash
HTTPDUSER=`ps axo user,comm | grep -E '[a]pache|[h]ttpd|[_]www|[w]ww-data|[n]ginx' | grep -v root | head -1 | cut -d\  -f1`
sudo setfacl -R -m u:"$HTTPDUSER":rwX -m u:`whoami`:rwX var
sudo setfacl -dR -m u:"$HTTPDUSER":rwX -m u:`whoami`:rwX var
```

Where "var" will be replaced with the specified folder

## Composer autoloader optimisation

The following command will be attempted

`composer dump-autoload --optimize --no-dev --classmap-authoritative`

When no composer is installed or no `composer.phar` file is uploaded this will fail and show error output. When autoload is generated locally using the build command this is no problem, since autoloader is already optimized.
