<?php

namespace Tests\Bazookas\CommonBundle\Utility;

use Bazookas\CommonBundle\Utility\HashUtility;
use Symfony\Bundle\FrameworkBundle\Test\KernelTestCase;

class HashUtilityTest extends KernelTestCase
{
  private $container;

  public function setUp()
  {
    self::bootKernel();
    $this->container = self::$kernel->getContainer();
  }

  public function testConvertIntegerToString() {
    $int = 1239;

    $string = HashUtility::alphaID($int, false, 8);

    $this->assertEquals(strlen($string), 8);
    $this->assertTrue(is_string($string));
  }

  public function testConvertStringToInteger() {
    $int = 1239;

    $string = HashUtility::alphaID($int, false, 8);
    $convertedInteger = HashUtility::alphaID($string, true, 8);

    $this->assertEquals($convertedInteger, $int);
  }
  
}
