<?php

namespace Bazookas\CronBundle\Repository;

use Bazookas\AdminBundle\Repository\Base\BaseRepository;
use Bazookas\CronBundle\Entity\Cron;

class CronRepository extends BaseRepository
{

  public function getEntityClass() {
    return Cron::class;
  }

  public function toggleStart($id) {
    $qb = $this->createQueryBuilder('cron');
    $qb
      ->andWhere($qb->expr()->eq('cron.id', ':id'))
      ->setParameter('id', $id)
    ;

    $cron = $qb->getQuery()->getOneOrNullResult();
    if (!empty($cron)) {
      $status = $cron->getStatus() === Cron::STATUS_SCHEDULED ? Cron::STATUS_INACTIVE : Cron::STATUS_SCHEDULED;

      if ($status === Cron::STATUS_SCHEDULED) {
        $cron->setNextRunOn(new \DateTime('now', new \DateTimeZone('UTC')));
      }

      $cron
        ->setFailureCount(0)
        ->setStatus($status)
      ;

      $this->entityManager->persist($cron);
      $this->entityManager->flush();
    }
  }
}
